<!--****************************************************************************
* $Id: README.md 6ae811c 2022-03-29 06:01:25 -0700 sthames42 $
*****************************************************************************-->
# gulp-doxygen

Tools and tasks for using [Doxygen] to build HTML documentation and [Intellisense
files][build-intellisense] for use with Visual Studio. Doxygen creates a documentation 
reference website based on the embedded source code documentation. It provides much 
more flexibility in documenting code than the XML style understood by Visual Studio.

<!-- toc -->

- [Installation](#installation)
- [Usage](#usage)
  * [Task Usage Help](#task-usage-help)
  * [Available Tasks](#available-tasks)
    + [build-docs](#build-docs)
    + [build-sense](#build-sense)
    + [clean-docs](#clean-docs)
- [API](#api)
  * [Module Function](#module-function)
  * [Options](#options)
  * [Functions](#functions)
    + [run](#run)
- [Building This Package](#building-this-package)
  * [Build Commands](#build-commands)
  * [TL;DR](#tldr)
- [See Also](#see-also)

<!-- tocstop -->

## Installation

  1) Set the endpoint for the [package registry] using [npm].
  1) Install this package as a development dependency:

```bash
npm install --save-dev @slcpub/gulp-doxygen
```
[package registry]: https://gitlab.com/slcon/pub/registry#npm

## Usage

```js
const gulp    = require('gulp');
const doxygen = require('@slcpub/gulp-doxygen').useGulp(gulp);
doxygen({options});
doxygen.addTasks([task...]);
```
  - `doxygen({options})` sets any desired [options].
  - `doxygen.addTasks(task...)` adds some or all of the available tasks to 
    `gulp` using `gulp.task()`.


### Task Usage Help

See [Task Usage Help in `gulp-common`][usage-help] for information on creating and displaying
usage help content for tasks.

[usage-help]: https://gitlab.com/slcon/pub/build/gulp-common#task-usage-help


### Available Tasks

These tasks may be added to the Gulp instance by calling [addTasks].

#### build-docs

Builds HTML documentation website into `${options.docsDir}/html`.

#### build-sense

Builds Intellisense XML file from Doxygen XML output into  
`${options.senseDir}/${package.json.name}.xml`.

#### clean-docs

Removes the output folders.

## API

### Module Function

The module function returned from `require()` can be used to set the module [options].

  - ***parameters***
    - `{object}` Module options.
  - ***returns***  
    - `{function}` Self-reference.

### Options

Module options may be set with the package [module function] or by setting the
options directly:

```js
const common = require('@slcpub/gulp-common');
common({options});
common.options = {options};
```

  - **doxyDir** `{string}`  
    Doxygen configuration file directory. Default is the current folder.
  - **doxyFile** `{string}`  
    Doxygen configuration file name. Default is `Doxygen.conf`.
  - **doxyBinPath** `{string}`  
    Doxygen executable path. Default is `C:\Program Files\Doxygen\bin`.
  - **docsDir** `{string}`  
    Output folder for files generated by Doxygen. Default is `./docs`.
  - **nodeBinPath** `{string}`  
    Node modules command file path. Default is `./node_modules/.bin'  
  - **senseDir** `{string}`  
    Output folder for Intellisense XML file. Default is `./docs`.

### Functions

#### addTasks 

Adds [available tasks](#available-tasks) to the [Gulp instance](#useGulp).

  - ***parameters***
    - `{string[]|string...}`
      Name of the task to add. All tasks are added if no names are supplied.

#### run

Run Doxygen to create documentation in `${options.doxyDir}`. Doxygen configuration
file relative file paths are resolved relative to the current working directory.

  - ***parameters***
    - `{object}` Environment variables to set.
  - ***returns***  
    - `{promise}` Resolved if successful, rejeted with fatal error info.

## Building This Package

### Build Commands

**`gulp set-registry`** takes input of a [personal access token] or [deploy token] and configures npm for 
[publishing to the package registry][publishing].

[**`npm version`**][npm version] updates **`package.json#version`**, runs **`gulp build`**, commits to
the local repo, and creates a tag for the version.

**`gulp undo-version`** may be run immediately after [npm version]. It reverts the changes and restores
the repository to it's prior state.

[**`npm publish`**][npm publish] is run after **`npm version`** to publish the package to npm registry as defined in 
**`package.json#publishConfig`**.

### TL;DR

After testing is complete and the package is ready to publish:

1) Run [**`npm version`**][npm version]
   * *preversion*: Runs **`npm test`** to run the library tests,
   * Updates the version number in `package.json`,
   * Commits changes and creates a version tag.

1) If, on second thought, the package is not ready,
   * Run **`gulp undo-version`** to remove the tag and restore the repository.

1) If ready to publish,
   * Run **`gulp push`** to update the remote repo with the new version.

1) Run **`gulp set-registry`** to configure npm for publishing to the package registry. This will require
   a [personal access token] or [deploy token].
   
1) Run [**`npm publish`**][npm publish] to publish the package to npm.

[npm]:                   https://docs.npmjs.com/about-npm
[package registry]:      https://docs.gitlab.com/ee/user/packages/package_registry/
[personal access token]: https://docs.gitlab.com/ee/user/profile/personal_access_tokens.html#personal-access-tokens
[deploy token]:          https://docs.gitlab.com/ee/user/project/deploy_tokens/index.html
[npm publish]:           https://docs.npmjs.com/cli/v8/commands/npm-publish
[npm version]:           https://docs.npmjs.com/cli/v6/commands/npm-version

## See Also

  - [Doxygen]
  - [How to Build Intellisense XML File from Doxygen XML Output][build-intellisense]

[doxygen]:            https://www.doxygen.nl/index.html
[build-intellisense]: https://gitlab.com/slcon/pub/doc/-/blob/trunk/BuildIntellisense.md
